HDU 4901 The Romantic Hero(二维dp)

题目大意:给你n个数字,然后分成两份,前边的一份里面的元素进行异或,后面的一份里面的元素进行与。分的时候按照给的先后数序取数,后面的里面的所有的元素的下标一定比前面的大。问你有多上种放元素的方法可以使得前面异或的值和后面与的值相等。

dp[x][y] 表示走到第x步,得到y这个数字一共有多少种方法。

但是需要注意这里得分一下,不能直接用dp数组存种数,你需要分一下从上一层过来的次数,和这一层自己可以到达的次数。然后取和的时候前后两个集合的种数进行乘法,注意边乘边取余。

顺便给一组数据:

4

3 3 3 3

输出:12。

The Romantic Hero

Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)

Total Submission(s): 459    Accepted Submission(s): 173

Problem Description

There is an old country and the king fell in love with a devil. The devil always asks the king to do some crazy things. Although the king used to be wise and beloved by his people. Now he is just like a boy in love and can’t refuse any request from the devil.
Also, this devil is looking like a very cute Loli.

You may wonder why this country has such an interesting tradition? It has a very long story, but I won‘t tell you :).

Let us continue, the party princess‘s knight win the algorithm contest. When the devil hears about that, she decided to take some action.

But before that, there is another party arose recently, the ‘MengMengDa‘ party, everyone in this party feel everything is ‘MengMengDa‘ and acts like a ‘MengMengDa‘ guy.

While they are very pleased about that, it brings many people in this kingdom troubles. So they decided to stop them.

Our hero z*p come again, actually he is very good at Algorithm contest, so he invites the leader of the ‘MengMengda‘ party xiaod*o to compete in an algorithm contest.

As z*p is both handsome and talkative, he has many girl friends to deal with, on the contest day, he find he has 3 dating to complete and have no time to compete, so he let you to solve the problems for him.

And the easiest problem in this contest is like that:

There is n number a_1,a_2,...,a_n on the line. You can choose two set S(a_s1,a_s2,..,a_sk) and T(a_t1,a_t2,...,a_tm). Each element in S should be at the left of every element in T.(si < tj for all i,j). S and T shouldn‘t be empty.

And what we want is the bitwise XOR of each element in S is equal to the bitwise AND of each element in T.

How many ways are there to choose such two sets? You should output the result modulo 10^9+7.

Input

The first line contains an integer T, denoting the number of the test cases.

For each test case, the first line contains a integers n.

The next line contains n integers a_1,a_2,...,a_n which are separated by a single space.

n<=10^3, 0 <= a_i <1024, T<=20.

Output

For each test case, output the result in one line.

Sample Input

2
3
1 2 3
4
1 2 3 3

Sample Output

1
4

Author

WJMZBMR

Source

2014 Multi-University Training Contest
4

#include <stdio.h>
#include <string.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <stdlib.h>
#define max( x, y )  ( ((x) > (y)) ? (x) : (y) )
#define min( x, y )  ( ((x) < (y)) ? (x) : (y) )
#define Mod 1000000007
#define LL long long

using namespace std;

const int maxn = 1200;
LL dp1[maxn][maxn];
LL dp2[maxn][maxn];
LL dp11[maxn][maxn];
LL dp22[maxn][maxn];

int num[maxn];

int main()
{
    int T;
    cin >>T;
    while(T--)
    {
        int n;
        scanf("%d",&n);
        for(int i = 1; i <= n; i++) scanf("%d", &num[i]);
        for(int i = 1; i <= n; i++)
            for(int j = 0; j < 1024; j++) dp1[i][j] = dp2[i][j] = 0;
        for(int i = 0; i < 1024; i++) dp11[1][i] = dp22[n][i] = 0;
        dp1[1][num[1]] ++;
        dp11[1][num[1]] ++;
        for(int i = 2; i <= n; i++)
        {
            dp1[i][num[i]]++;
            for(int j = 0; j < 1024; j++)
            {
                if(dp11[i-1][j])
                {
                    dp1[i][j^num[i]] += dp11[i-1][j];
                    dp1[i][j^num[i]] %= Mod;
                }
            }

            for(int j = 0; j < 1024; j++)
            {
                dp11[i][j] = dp1[i][j]+dp11[i-1][j];
                dp11[i][j] %= Mod;
            }
        }
        dp2[n][num[n]]++;
        dp22[n][num[n]]++;
        for(int i = n-1; i >= 1; i--)
        {
            dp2[i][num[i]] ++;
            for(int j = 0; j < 1024; j++)
            {
                if(dp22[i+1][j])
                {
                    dp2[i][j&num[i]] += dp22[i+1][j];
                    dp2[i][j&num[i]] %= Mod;
                }
            }

            for(int j = 0; j < 1024; j++)
            {
                dp22[i][j] = dp2[i][j]+dp22[i+1][j];
                dp22[i][j] %= Mod;
            }
        }
        for(int i = n-1; i >= 1; i--)
        {
            for(int j = 0; j < 1024; j++)
            {
                dp2[i][j] += dp2[i+1][j];
                dp2[i][j] %= Mod;
            }
        }
        LL sum = 0;
        for(int i = 1; i <= n; i++)
        {
            for(int j = 0; j < 1024; j++)
            {
                if(dp1[i][j] && dp2[i+1][j])
                {
                    sum += ((dp1[i][j]%Mod)*(dp2[i+1][j]%Mod))%Mod;
                }
            }
        }
        cout<<(sum%Mod)<<endl;
    }
    return 0;
}

HDU 4901 The Romantic Hero(二维dp),布布扣,bubuko.com

时间: 2024-12-25 05:25:09

HDU 4901 The Romantic Hero(二维dp)的相关文章

hdu 4901 The Romantic Hero(计数dp)2014多校训练第4场1005

The Romantic Hero                                                                               Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Problem Description There is an old country and the king fell in lov

2014多校第四场1005 || HDU 4901 The Romantic Hero (DP)

题目链接 题意 :给你一个数列,让你从中挑选一些数组成集合S,挑另外一些数组成集合T,要求是S中的每一个数在原序列中的下标要小于T中每一个数在原序列中下标.S中所有数按位异或后的值要与T中所有的数按位与的值相同,问能找出多少符合要求的组合. 思路 :比赛的时候有点没有头绪,后来二师兄想出了状态转移方程,YN又改了很多细节,最后才A的.总之是个别扭的DP..... 一开始是 _xor[i][j^a[i]] += _xor[i-1][j] :j 的下一个状态 就是异或上a[i],这个数组所代表的意思

HDU 4901 The Romantic Hero(DP)

HDU 4901 The Romantic Hero 题目链接 题意:给定一个序列,要求找一个分界点,然后左边选一些数异或和,和右边选一些数且和相等,问有几种方法 思路:dp,从左往右和从右往左dp,求出异或和且的个数,然后找一个分界点,使得一边必须在分界点上,一边随意,然后根据乘法原理和加法原理计算 代码: #include <cstdio> #include <cstring> typedef __int64 ll; const int N = 1024; const int

hdu 4901 The Romantic Hero (dp+背包问题)

题意: 有n个数,从n个数中选出两个集合s和集合t,保证原序列中,集合s中的元素都在 集合t中元素的左边.且要求集合s中元素做抑或运算的值与集合t中元素做与运算的 值相等.问能选出多少种这样的集合s和t. 算法: 左右dp. 用dp[i][j]表示前i个数 做抑或运算得到j的方法数.最后一个值取不取到都不一定. 故为背包的问题.右边也是一样. 枚举时可能出现重复.枚举到第i个和枚举第i+1个可能重复.所以要枚举一个中间值. 这个中间值是归到s集的,因为抑或支持逆运算,而与是不支持的. 所以最后d

HDU 5074 Hatsune Miku(简单二维dp)

题目大意:给你一些音符之间的联系,给你一个串,让你求出这个串的最大值.-1的时候可以任意替代,其他情况必须为序列上的数. 解题思路:简单二维dp,分情况处理就可以了啊. Hatsune Miku Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others) Total Submission(s): 637    Accepted Submission(s): 458 Problem De

hdu 4901 The Romantic Hero 计数dp,位计算

The Romantic Hero Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 1128    Accepted Submission(s): 469 Problem Description There is an old country and the king fell in love with a devil. The d

HDU 4901 The Romantic Hero 题解——S.B.S.

The Romantic Hero Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 1675    Accepted Submission(s): 705 Problem Description There is an old country and the king fell in love with a devil. The de

HDU 4901 The Romantic Hero

The Romantic Hero Time Limit: 3000MS   Memory Limit: 131072KB   64bit IO Format: %I64d & %I64u Description 开头背景介绍无用 There is an old country and the king fell in love with a devil. The devil always asks the king to do some crazy things. Although the k

HDU - 4901 The Romantic Hero(dp)

https://vjudge.net/problem/HDU-4901 题意 给n个数,构造两个集合,使第一个集合的异或和等于第二个集合的相与和,且要求第一个集合的元素下标都小于第二个集合的元素下标.问方案数 分析 dp来做.dp1[i][j]表示0~i的元素异或和为j的个数.dp2[i][j]表示i~n-1的元素相与和为j的个数.注意状态转移时要同时计算第i个数参与或不参与的情况,且dp1的第一维不能取到n-1,类似的,dp2的第一维不能取0.统计最终答案时需要合并,那么怎么才能防止重复呢?这